Subject: bug#64143: 29.0.60; find-function-search-for-symbol truncates library path

From: Eli Zaretskii <[email-masked]>
Date: Sun, 18 Jun 2023 10:54:38 +0300

> From: Troy Brown <[email-masked]>
> Date: Sun, 18 Jun 2023 00:45:12 -0400
> 
> When user-emacs-directory contains "emacs.el" in it's path (e.g.,
> "~/.emacs.elpa"), which is much easier these days with the availability
> of --init-directory, the find-function-search-for-symbol truncates the
> library path after "emacs".

What do you mean by "truncates the library path"?  Do you mean
truncation of the file name 'emacs.el' to yield just 'emacs'? or do
you mean something else?  (To avoid confusion, please don't use "path"
to refer to file names, only to refer to lists of directories in the
style of PATH or load-path.)

> I was experimenting with a different user directory (i.e.,
> "--init-directory=~/.emacs.elpa") and was surprised to find out that the
> Help system was breaking when using this path.  When looking up a symbol
> in the Help system (e.g., "C-h f company-mode RET") and then attempting
> to visit the source file from the help window (i.e., help-view-source),
> if the symbol belongs to an installed package (where the source is
> under the "elpa" directory beneath user-emacs-directory), it will
> generate the following error message:
> 
>   Can't find library: /home/troy/.emacs

This says it cannot find ".emacs", not "emacs".  So is your init file
called ".emacs.el" or (as you mentioned above) "emacs.el"?

> Toggling "debug-on-error" and repeating the above, I can generate a
> backtrace for this as follows:
> 
> Debugger entered--Lisp error: (file-error "Can't find library"
> "/home/troy/.emacs")
>   find-library-name("/home/troy/.emacs")
>   #<subr find-function-search-for-symbol>(company-mode nil
> "/home/troy/.emacs.elpa/elpa/company-20230416.2034/company.el")
>   ad-Advice-find-function-search-for-symbol(#<subr
> find-function-search-for-symbol> company-mode nil
> "/home/troy/.emacs.elpa/elpa/company-20230416.2034/company.el")
>   apply(ad-Advice-find-function-search-for-symbol #<subr
> find-function-search-for-symbol> (company-mode nil
> "/home/troy/.emacs.elpa/elpa/company-20230416.2034/company.el"))
>   find-function-search-for-symbol(company-mode nil
> "/home/troy/.emacs.elpa/elpa/company-20230416.2034/company.el")
>   help-function-def--button-function(company-mode
> "/home/troy/.emacs.elpa/elpa/company-20230416.2034/company.el" nil)
>   help-view-source()
>   funcall-interactively(help-view-source)
>   call-interactively(help-view-source nil nil)
>   command-execute(help-view-source)
> 
> I believe the following snippet of code in
> find-function-search-for-symbol is to blame for this:
> 
>     (when (string-match "\\.emacs\\(.el\\)" library)
>       (setq library (substring library 0 (match-beginning 1))))
> 
> The regex likely should be improved to only match .emacs or .emacs.el at
> the end of the path, not in the middle of it.

Does the patch below fix this problem?

Also, I see that you have some advice installed for
find-function-search-for-symbol.  Would you please verify that
removing that advice still produces the problem in Emacs 29?

diff --git a/lisp/emacs-lisp/find-func.el b/lisp/emacs-lisp/find-func.el
index f9f919a..bf890fc 100644
--- a/lisp/emacs-lisp/find-func.el
+++ b/lisp/emacs-lisp/find-func.el
@@ -407,7 +407,7 @@ find-function-search-for-symbol
       (setq library (substring library 0 (match-beginning 1))))
     ;; Strip extension from .emacs.el to make sure symbol is searched in
     ;; .emacs too.
-    (when (string-match "\\.emacs\\(.el\\)" library)
+    (when (string-match "\\.emacs\\(.el\\)\\'" library)
       (setq library (substring library 0 (match-beginning 1))))
     (let* ((filename (find-library-name library))
 	   (regexp-symbol (cdr (assq type find-function-regexp-alist))))